Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -3271,34 +2595,34 @@
 
         // View the roles settings
         if (has_any_capability(array('moodle/role:assign', 'moodle/role:safeoverride','moodle/role:override', 'moodle/role:manage'), $usercontext)) {
-            $roleskey = $usersetting->add(get_string('roles'), null, self::TYPE_SETTING);
+            $roles = $usersetting->add(get_string('roles'), null, self::TYPE_SETTING);
 
             $url = new moodle_url('/admin/roles/usersroles.php', array('userid'=>$user->id, 'courseid'=>$course->id));
-            $usersetting->get($roleskey)->add(get_string('thisusersroles', 'role'), $url, self::TYPE_SETTING);
+            $roles->add(get_string('thisusersroles', 'role'), $url, self::TYPE_SETTING);
 
             $assignableroles = get_assignable_roles($usercontext, ROLENAME_BOTH);
 
             if (!empty($assignableroles)) {
                 $url = new moodle_url('/admin/roles/assign.php', array('contextid'=>$usercontext->id,'userid'=>$user->id, 'courseid'=>$course->id));
-                $usersetting->get($roleskey)->add(get_string('assignrolesrelativetothisuser', 'role'), $url, self::TYPE_SETTING);
+                $roles->add(get_string('assignrolesrelativetothisuser', 'role'), $url, self::TYPE_SETTING);
             }
 
             if (has_capability('moodle/role:review', $usercontext) || count(get_overridable_roles($usercontext, ROLENAME_BOTH))>0) {
                 $url = new moodle_url('/admin/roles/permissions.php', array('contextid'=>$usercontext->id,'userid'=>$user->id, 'courseid'=>$course->id));
-                $usersetting->get($roleskey)->add(get_string('permissions', 'role'), $url, self::TYPE_SETTING);
+                $roles->add(get_string('permissions', 'role'), $url, self::TYPE_SETTING);
             }
 
             $url = new moodle_url('/admin/roles/check.php', array('contextid'=>$usercontext->id,'userid'=>$user->id, 'courseid'=>$course->id));
-            $usersetting->get($roleskey)->add(get_string('checkpermissions', 'role'), $url, self::TYPE_SETTING);
+            $roles->add(get_string('checkpermissions', 'role'), $url, self::TYPE_SETTING);
         }
 
         // Portfolio
         if ($currentuser && !empty($CFG->enableportfolios) && has_capability('moodle/portfolio:export', $systemcontext)) {
             require_once($CFG->libdir . '/portfoliolib.php');
             if (portfolio_instances(true, false)) {
-                $portfoliokey = $usersetting->add(get_string('portfolios', 'portfolio'), null, self::TYPE_SETTING);
-                $usersetting->get($portfoliokey)->add(get_string('configure', 'portfolio'), new moodle_url('/user/portfolio.php'), self::TYPE_SETTING);
-                $usersetting->get($portfoliokey)->add(get_string('logs', 'portfolio'), new moodle_url('/user/portfoliologs.php'), self::TYPE_SETTING);
+                $portfolio = $usersetting->add(get_string('portfolios', 'portfolio'), null, self::TYPE_SETTING);
+                $portfolio->add(get_string('configure', 'portfolio'), new moodle_url('/user/portfolio.php'), self::TYPE_SETTING);
+                $portfolio->add(get_string('logs', 'portfolio'), new moodle_url('/user/portfoliologs.php'), self::TYPE_SETTING);
             }
         }
 
@@ -3324,20 +2648,19 @@
             $usersetting->add(get_string('editmymessage', 'message'), $url, self::TYPE_SETTING);
         }
 
-        return $usersettingskey;
+        return $usersetting;
     }
 
     /**
      * Loads block specific settings in the navigation
      *
-     * @return string The key that can be used to retrieve the navigation node
+     * @return navigation_node
      */
     protected function load_block_settings() {
         global $CFG;
 
-        $blocksettingskey = $this->add(print_context_name($this->context));
-        $blocknode = $this->get($blocksettingskey);
-        $blocknode->forceopen = true;
+        $blocknode = $this->add(print_context_name($this->context));
+        $blocknode->force_open();
 
         // Assign local roles
         $assignurl = new moodle_url('/'.$CFG->admin.'/roles/assign.php', array('contextid'=>$this->context->id));
@@ -3354,20 +2677,19 @@
             $blocknode->add(get_string('checkpermissions', 'role'), $url, self::TYPE_SETTING);
         }
 
-        return $blocksettingskey;
+        return $blocknode;
     }
 
     /**
      * Loads category specific settings in the navigation
      *
-     * @return string
+     * @return navigation_node
      */
     protected function load_category_settings() {
         global $CFG;
 
-        $blocksettingskey = $this->add(print_context_name($this->context));
-        $blocknode = $this->get($blocksettingskey);
-        $blocknode->forceopen = true;
+        $blocknode = $this->add(print_context_name($this->context));
+        $blocknode->force_open();
 
         if ($this->page->user_is_editing() && has_capability('moodle/category:manage', $this->context)) {
             $blocknode->add(get_string('editcategorythis'), new moodle_url('/course/editcategory.php', array('id' => $this->context->instanceid)));
@@ -3389,7 +2711,7 @@
             $blocknode->add(get_string('checkpermissions', 'role'), $url, self::TYPE_SETTING);
         }
 
-        return $blocksettingskey;
+        return $blocknode;
     }
 
     /**
@@ -3420,6 +2742,7 @@
     /**
      * This function loads all of the front page settings into the settings navigation.
      * This function is called when the user is on the front page, or $COURSE==$SITE
+     * @return navigation_node
      */
     protected function load_front_page_settings($forceopen = false) {
         global $SITE, $CFG;
@@ -3427,9 +2750,10 @@
         $course = clone($SITE);
         $coursecontext = get_context_instance(CONTEXT_COURSE, $course->id);   // Course context
 
-        $frontpagekey = $this->add(get_string('frontpagesettings'), null, self::TYPE_SETTING, null, 'frontpage');
-        $frontpage = $this->get($frontpagekey);
-        $frontpage->forceopen = $forceopen;
+        $frontpage = $this->add(get_string('frontpagesettings'), null, self::TYPE_SETTING, null, 'frontpage');
+        if ($forceopen) {
+            $frontpage->force_open();
+        }
         $frontpage->id = 'frontpagesettings';
 
         if (has_capability('moodle/course:update', $coursecontext)) {
@@ -3513,20 +2837,10 @@
             $url = new moodle_url('/files/index.php', array('id'=>$course->id));
             $frontpage->add(get_string('files'), $url, self::TYPE_SETTING, null, null, new pix_icon('i/files', ''));
         }
+        return $frontpage;
     }
 
     /**
-     * This function removes all root branches that have no children
-     */
-    public function remove_empty_root_branches() {
-        foreach ($this->children as $key=>$node) {
-            if ($node->nodetype != self::NODETYPE_BRANCH || count($node->children)===0) {
-                $this->remove_child($key);
-            }
-        }
-    }
-
-    /**
      * This function marks the cache as volatile so it is cleared during shutdown
      */
     public function clear_cache() {
@@ -3547,8 +2861,6 @@
     protected $nodetype = array('node','branch');
     /** @var array */
     protected $expandable = array();
-    /** @var int */
-    protected $expansionceiling = array();
     /**
      * Turns a branch and all of its children into XML
      *
@@ -3562,6 +2874,7 @@
     /**
      * Set the expandable items in the array so that we have enough information
      * to attach AJAX events
+     * @param array $expandable
      */
     public function set_expandable($expandable) {
         foreach ($expandable as $node) {
@@ -3569,19 +2882,11 @@
         }
     }
     /**
-     * Sets the upper limit for expandable nodes. Any nodes that are of the specified
-     * type or larger will not be expandable
-     *
-     * @param int $expansionceiling One of navigation_node::TYPE_*
-     */
-    public function set_expansionceiling($expansionceiling) {
-        $tihs->expansionceiling = $expansionceiling;
-    }
-    /**
      * Recusively converts a child node and its children to XML for output
      *
      * @param navigation_node $child The child to convert
      * @param int $depth Pointlessly used to track the depth of the XML structure
+     * @return string JSON
      */
     protected function convert_child($child, $depth=1) {
         global $OUTPUT;
@@ -3619,8 +2924,6 @@
         if (array_key_exists((string)$child->key, $this->expandable)) {
             $attributes['expandable'] = $child->key;
             $child->add_class($this->expandable[$child->key]['id']);
-        } else if ($child->type >= $this->expansionceiling) {
-            $attributes['expansionceiling'] = $child->key;
         }
 
         if (count($child->classes)>0) {
@@ -3632,7 +2935,7 @@
             $attributes['link'] = $child->action->out();
         }
         $attributes['hidden'] = ($child->hidden);
-        $attributes['haschildren'] = (count($child->children)>0 || $child->type == navigation_node::TYPE_CATEGORY);
+        $attributes['haschildren'] = ($child->children->count()>0 || $child->type == navigation_node::TYPE_CATEGORY);
 
         if (count($child->children)>0) {
             $attributes['children'] = array();
Index: moodle/lib/outputrenderers.php
--- moodle/lib/outputrenderers.php Base (1.179)
+++ moodle/lib/outputrenderers.php Locally Modified (Based On 1.179)
@@ -1990,7 +1990,7 @@
             // this applies to the li item which contains all child lists too
             $content = $item->content($this);
             $liclasses = array($item->get_css_type());
-            if (!$item->forceopen || (!$item->forceopen && $item->collapse) || (count($item->children)==0  && $item->nodetype==navigation_node::NODETYPE_BRANCH)) {
+            if (!$item->forceopen || (!$item->forceopen && $item->collapse) || ($item->children->count()==0  && $item->nodetype==navigation_node::NODETYPE_BRANCH)) {
                 $liclasses[] = 'collapsed';
             }
             if ($item->isactive === true) {
@@ -1999,7 +1999,7 @@
             $liattr = array('class'=>join(' ',$liclasses));
             // class attribute on the div item which only contains the item content
             $divclasses = array('tree_item');
-            if (!empty($item->children)  || $item->nodetype==navigation_node::NODETYPE_BRANCH) {
+            if ($item->children->count()>0  || $item->nodetype==navigation_node::NODETYPE_BRANCH) {
                 $divclasses[] = 'branch';
             } else {
                 $divclasses[] = 'leaf';
@@ -2026,9 +2026,65 @@
      * @return string XHTML navbar
      */
     public function navbar() {
-        return $this->page->navbar->content();
+        //return $this->page->navbar->content();
+
+        $items = $this->page->navbar->get_items();
+
+        $count = 0;
+
+        $htmlblocks = array();
+        // Iterate the navarray and display each node
+        foreach ($items as $item) {
+            $htmlblocks[] = html_writer::tag('li', $this->render($item));
     }
 
+        // XHTML
+        return join(get_separator(), $htmlblocks);
+    }
+
+    protected function render_navigation_node(navigation_node $item) {
+        $content = $item->get_content();
+        $title = $item->get_title();
+        if ($item->icon instanceof renderable) {
+            $icon = $this->render($item->icon);
+            $content = $icon.'&nbsp;'.$content; // use CSS for spacing of icons
+        }
+        if ($item->helpbutton !== null) {
+            $content = trim($item->helpbutton).html_writer::tag('span', $content, array('class'=>'clearhelpbutton'));
+        }
+        if ($content === '') {
+            continue;
+        }
+        if ($item->action instanceof action_link) {
+            //TODO: to be replaced with something else
+            $link = $item->action;
+            if ($item->hidden) {
+                $link->add_class('dimmed');
+            }
+            $content = $this->output->render($link);
+        } else if ($item->action instanceof moodle_url) {
+            $attributes = array();
+            if ($title !== '') {
+                $attributes['title'] = $title;
+            }
+            if ($item->hidden) {
+                $attributes['class'] = 'dimmed_text';
+            }
+            $content = html_writer::link($item->action, $content, $attributes);
+
+        } else if (is_string($item->action) || empty($item->action)) {
+            $attributes = array();
+            if ($title !== '') {
+                $attributes['title'] = $title;
+            }
+            if ($item->hidden) {
+                $attributes['class'] = 'dimmed_text';
+            }
+            $content = html_writer::tag('span', $content, $attributes);
+        }
+        return $content;
+    }
+
     /**
      * Accessibility: Right arrow-like character is
      * used in the breadcrumb trail, course navigation menu
Index: moodle/lib/outputrequirementslib.php
--- moodle/lib/outputrequirementslib.php Base (1.22)
+++ moodle/lib/outputrequirementslib.php Locally Modified (Based On 1.22)
@@ -379,7 +379,8 @@
                 case 'core_dock':
                     $module = array('name'     => 'core_dock',
                                     'fullpath' => '/blocks/dock.js',
-                                    'requires' => array('base', 'cookie', 'dom', 'io', 'node', 'event-custom', 'event-mouseenter', 'yui2-container'));
+                                    'requires' => array('base', 'cookie', 'dom', 'io', 'node', 'event-custom', 'event-mouseenter', 'yui2-container'),
+                                    'strings' => array(array('addtodock', 'block'),array('undockitem', 'block'),array('undockall', 'block')));
                     break;
                 case 'core_calendar':
                     $module = array('name'     => 'core_calendar',
Index: moodle/lib/pagelib.php
--- moodle/lib/pagelib.php Base (1.176)
+++ moodle/lib/pagelib.php Locally Modified (Based On 1.176)
@@ -171,7 +171,7 @@
     protected $_button = '';
 
     protected $_theme = null;
-    /** @var null|global_navigation Contains the global navigation structure*/
+    /** @var global_navigation Contains the global navigation structure*/
     protected $_navigation = null;
     /** @var null|settings_navigation Contains the settings navigation structure*/
     protected $_settingsnav = null;
@@ -520,7 +520,7 @@
      */
     protected function magic_get_navigation() {
         if ($this->_navigation === null) {
-            $this->_navigation = new global_navigation();
+            $this->_navigation = new global_navigation($this);
         }
         return $this->_navigation;
     }
Index: moodle/mod/assignment/type/online/assignment.class.php
--- moodle/mod/assignment/type/online/assignment.class.php Base (1.88)
+++ moodle/mod/assignment/type/online/assignment.class.php Locally Modified (Based On 1.88)
@@ -348,13 +348,13 @@
             $node->add(get_string('viewmysubmission', 'assignment'), $link, navigation_node::TYPE_SETTING);
 
             if (!empty($submission->timemodified)) {
-                $key = $node->add(get_string('submitted', 'assignment') . ' ' . userdate($submission->timemodified));
-                $node->get($key)->text = preg_replace('#([^,])\s#', '$1&nbsp;', $node->get($key)->text);
-                $node->get($key)->add_class('note');
+                $submittednode = $node->add(get_string('submitted', 'assignment') . ' ' . userdate($submission->timemodified));
+                $submittednode->text = preg_replace('#([^,])\s#', '$1&nbsp;', $submittednode->text);
+                $submittednode->add_class('note');
                 if ($submission->timemodified <= $this->assignment->timedue || empty($this->assignment->timedue)) {
-                    $node->get($key)->add_class('early');
+                    $submittednode->add_class('early');
                 } else {
-                    $node->get($key)->add_class('late');
+                    $submittednode->add_class('late');
                 }
             }
         }
Index: moodle/mod/assignment/type/upload/assignment.class.php
--- moodle/mod/assignment/type/upload/assignment.class.php Base (1.97)
+++ moodle/mod/assignment/type/upload/assignment.class.php Locally Modified (Based On 1.97)
@@ -1084,13 +1084,13 @@
             $link = new moodle_url('/mod/assignment/view.php', array('id'=>$this->cm->id));
             $node->add(get_string('viewmysubmission', 'assignment'), $link, navigation_node::TYPE_SETTING);
             if (!empty($submission->timemodified)) {
-                $key = $node->add(get_string('submitted', 'assignment') . ' ' . userdate($submission->timemodified));
-                $node->get($key)->text = preg_replace('#([^,])\s#', '$1&nbsp;', $node->get($key)->text);
-                $node->get($key)->add_class('note');
+                $submittednode = $node->add(get_string('submitted', 'assignment') . ' ' . userdate($submission->timemodified));
+                $submittednode->text = preg_replace('#([^,])\s#', '$1&nbsp;', $submittednode->text);
+                $submittednode->add_class('note');
                 if ($submission->timemodified <= $this->assignment->timedue || empty($this->assignment->timedue)) {
-                    $node->get($key)->add_class('early');
+                    $submittednode->add_class('early');
                 } else {
-                    $node->get($key)->add_class('late');
+                    $submittednode->add_class('late');
                 }
             }
         }
@@ -1100,15 +1100,15 @@
             $fs = get_file_storage();
             if ($files = $fs->get_area_files($this->context->id, 'assignment_submission', $USER->id, "timemodified", false)) {
                 if (!$this->drafts_tracked() or !$this->isopen() or $this->is_finalized($submission)) {
-                    $filekey = $node->add(get_string('submission', 'assignment'));
+                    $filenode = $node->add(get_string('submission', 'assignment'));
                 } else {
-                    $filekey = $node->add(get_string('submissiondraft', 'assignment'));
+                    $filenode = $node->add(get_string('submissiondraft', 'assignment'));
                 }
                 foreach ($files as $file) {
                     $filename = $file->get_filename();
                     $mimetype = $file->get_mimetype();
                     $link = file_encode_url($CFG->wwwroot.'/pluginfile.php', '/'.$this->context->id.'/assignment_submission/'.$USER->id.'/'.$filename);
-                    $node->get($filekey)->add($filename, $link, navigation_node::TYPE_SETTING, null, null, new pix_icon(file_mimetype_icon($mimetype),''));
+                    $filenode->add($filename, $link, navigation_node::TYPE_SETTING, null, null, new pix_icon(file_mimetype_icon($mimetype),''));
                 }
             }
         }
Index: moodle/mod/assignment/type/uploadsingle/assignment.class.php
--- moodle/mod/assignment/type/uploadsingle/assignment.class.php Base (1.55)
+++ moodle/mod/assignment/type/uploadsingle/assignment.class.php Locally Modified (Based On 1.55)
@@ -204,13 +204,13 @@
             $link = new moodle_url('/mod/assignment/view.php', array('id'=>$this->cm->id));
             $node->add(get_string('viewmysubmission', 'assignment'), $link, navigation_node::TYPE_SETTING);
             if (!empty($submission->timemodified)) {
-                $key = $node->add(get_string('submitted', 'assignment') . ' ' . userdate($submission->timemodified));
-                $node->get($key)->text = preg_replace('#([^,])\s#', '$1&nbsp;', $node->get($key)->text);
-                $node->get($key)->add_class('note');
+                $submissionnode = $node->add(get_string('submitted', 'assignment') . ' ' . userdate($submission->timemodified));
+                $submissionnode->text = preg_replace('#([^,])\s#', '$1&nbsp;', $submissionnode->text);
+                $submissionnode->add_class('note');
                 if ($submission->timemodified <= $this->assignment->timedue || empty($this->assignment->timedue)) {
-                    $node->get($key)->add_class('early');
+                    $submissionnode->add_class('early');
                 } else {
-                    $node->get($key)->add_class('late');
+                    $submissionnode->add_class('late');
                 }
             }
         }
@@ -219,12 +219,12 @@
         if ($submission && has_capability('mod/assignment:submit', $this->context) && $this->count_user_files($USER->id)) {
             $fs = get_file_storage();
             if ($files = $fs->get_area_files($this->context->id, 'assignment_submission', $USER->id, "timemodified", false)) {
-                $filekey = $node->add(get_string('submission', 'assignment'));
+                $filenode = $node->add(get_string('submission', 'assignment'));
                 foreach ($files as $file) {
                     $filename = $file->get_filename();
                     $mimetype = $file->get_mimetype();
                     $link = file_encode_url($CFG->wwwroot.'/pluginfile.php', '/'.$this->context->id.'/assignment_submission/'.$USER->id.'/'.$filename);
-                    $node->get($filekey)->add($filename, $link, navigation_node::TYPE_SETTING, null, null, new pix_icon(file_mimetype_icon($mimetype), ''));
+                    $filenode->add($filename, $link, navigation_node::TYPE_SETTING, null, null, new pix_icon(file_mimetype_icon($mimetype), ''));
                 }
             }
         }
Index: moodle/mod/chat/lib.php
--- moodle/mod/chat/lib.php Base (1.166)
+++ moodle/mod/chat/lib.php Locally Modified (Based On 1.166)
@@ -1274,8 +1274,7 @@
 
     $chatusers = chat_get_users($cm->instance, $currentgroup, $cm->groupingid);
     if (is_array($chatusers) && count($chatusers)>0) {
-        $userskey = $navigation->add(get_string('currentusers', 'chat'));
-        $users = $navigation->get($userskey);
+        $users = $navigation->add(get_string('currentusers', 'chat'));
         foreach ($chatusers as $chatuser) {
             $userlink = new moodle_url('/user/view.php', array('id'=>$chatuser->id,'course'=>$course->id));
             $users->add(fullname($chatuser).' '.format_time(time() - $chatuser->lastmessageping), $userlink, navigation_node::TYPE_USER, null, null, new pix_icon('c/user', ''));
@@ -1294,8 +1293,8 @@
     $chat = $DB->get_record("chat", array("id" => $PAGE->cm->instance));
 
     if ($chat->chattime && $chat->schedule) {
-        $key = $chatnode->add(get_string('nextsession', 'chat').': '.userdate($chat->chattime).' ('.usertimezone($USER->timezone));
-        $chatnode->get($key)->add_class('note');
+        $nextsessionnode = $chatnode->add(get_string('nextsession', 'chat').': '.userdate($chat->chattime).' ('.usertimezone($USER->timezone));
+        $nextsessionnode->add_class('note');
     }
 
     $currentgroup = groups_get_activity_group($PAGE->cm, true);
Index: moodle/mod/data/lib.php
--- moodle/mod/data/lib.php Base (1.270)
+++ moodle/mod/data/lib.php Locally Modified (Based On 1.270)
@@ -2848,8 +2848,8 @@
     /// Check the number of entries required against the number of entries already made (doesn't apply to teachers)
     if ($data->requiredentries > 0 && $numentries < $data->requiredentries && !has_capability('mod/data:manageentries', get_context_instance(CONTEXT_MODULE, $cm->id))) {
         $data->entriesleft = $data->requiredentries - $numentries;
-        $key = $navigation->add(get_string('entrieslefttoadd', 'data', $data));
-        $navigation->get($key)->add_class('note');
+        $entriesnode = $navigation->add(get_string('entrieslefttoadd', 'data', $data));
+        $entriesnode->add_class('note');
     }
 
     $navigation->add(get_string('list', 'data'), new moodle_url('/mod/data/view.php', array('d'=>$cm->instance)));
@@ -2904,8 +2904,7 @@
             $defaultemplate = 'singletemplate';
         }
 
-        $templatekey = $datanode->add(get_string('templates', 'data'));
-        $templates = $datanode->get($templatekey);
+        $templates = $datanode->add(get_string('templates', 'data'));
 
         $templatelist = array ('listtemplate', 'singletemplate', 'asearchtemplate', 'addtemplate', 'rsstemplate', 'csstemplate', 'jstemplate');
         foreach ($templatelist as $template) {
Index: moodle/mod/feedback/lib.php
--- moodle/mod/feedback/lib.php Base (1.66)
+++ moodle/mod/feedback/lib.php Locally Modified (Based On 1.66)
@@ -2277,19 +2277,15 @@
             print_error('badcontext');
     }
 
-    // $capabilities = feedback_load_capabilities($PAGE->cm->id);
-
-    // if($capabilities->edititems) {
-    if(has_capability('mod/feedback:edititems', $context)) {
-        $qkey = $feedbacknode->add(get_string('questions', 'feedback'));
-        $feedbacknode->get($qkey)->add(get_string('edit_items', 'feedback'), new moodle_url('/mod/feedback/edit.php', array('id'=>$PAGE->cm->id, 'do_show'=>'edit')));
-        $feedbacknode->get($qkey)->add(get_string('export_questions', 'feedback'), new moodle_url('/mod/feedback/export.php', array('id'=>$PAGE->cm->id, 'action'=>'exportfile')));
-        $feedbacknode->get($qkey)->add(get_string('import_questions', 'feedback'), new moodle_url('/mod/feedback/import.php', array('id'=>$PAGE->cm->id)));
-        $feedbacknode->get($qkey)->add(get_string('templates', 'feedback'), new moodle_url('/mod/feedback/edit.php', array('id'=>$PAGE->cm->id, 'do_show'=>'templates')));
+    if (has_capability('mod/feedback:edititems', $context)) {
+        $questionnode = $feedbacknode->add(get_string('questions', 'feedback'));
+        $questionnode->add(get_string('edit_items', 'feedback'), new moodle_url('/mod/feedback/edit.php', array('id'=>$PAGE->cm->id, 'do_show'=>'edit')));
+        $questionnode->add(get_string('export_questions', 'feedback'), new moodle_url('/mod/feedback/export.php', array('id'=>$PAGE->cm->id, 'action'=>'exportfile')));
+        $questionnode->add(get_string('import_questions', 'feedback'), new moodle_url('/mod/feedback/import.php', array('id'=>$PAGE->cm->id)));
+        $questionnode->add(get_string('templates', 'feedback'), new moodle_url('/mod/feedback/edit.php', array('id'=>$PAGE->cm->id, 'do_show'=>'templates')));
     }
 
-    // if($capabilities->viewreports) {
-    if(has_capability('mod/feedback:viewreports', $context)) {
+    if (has_capability('mod/feedback:viewreports', $context)) {
         $feedback = $DB->get_record('feedback', array('id'=>$PAGE->cm->instance));
         if($feedback->course == SITEID){
             $feedbacknode->add(get_string('analysis', 'feedback'), new moodle_url('/mod/feedback/analysis_course.php', array('id'=>$PAGE->cm->id, 'course'=>$PAGE->course->id,'do_show'=>'analysis')));
Index: moodle/mod/forum/lib.php
--- moodle/mod/forum/lib.php Base (1.858)
+++ moodle/mod/forum/lib.php Locally Modified (Based On 1.858)
@@ -7973,13 +7973,13 @@
     if (!is_array($discussions) || count($discussions)==0) {
         return;
     }
-    $discussionkey = $navref->add(get_string('discussions', 'forum').' ('.$discussioncount.')');
-    $navref->get($discussionkey)->mainnavonly = true;
+    $discussionnode = $navref->add(get_string('discussions', 'forum').' ('.$discussioncount.')');
+    $discussionnode->mainnavonly = true;
 
     foreach ($discussions as $discussion) {
         $icon = new pix_icon('i/feedback', '');
         $url = new moodle_url('/mod/forum/discuss.php', array('d'=>$discussion->discussion));
-        $navref->get($discussionkey)->add($discussion->subject, $url, navigation_node::TYPE_SETTING, null, null, $icon);
+        $discussionnode->add($discussion->subject, $url, navigation_node::TYPE_SETTING, null, null, $icon);
     }
 
     if ($discussioncount > count($discussions)) {
@@ -7988,7 +7988,7 @@
         } else {
             $url = new moodle_url('/mod/forum/view.php', array('id'=>$cm->id));
         }
-        $childkey = $navref->get($discussionkey)->add(get_string('viewalldiscussions', 'forum'), $url, navigation_node::TYPE_SETTING, null, null, $icon);
+        $discussionnode->add(get_string('viewalldiscussions', 'forum'), $url, navigation_node::TYPE_SETTING, null, null, $icon);
     }
 
     $index = 0;
@@ -8002,13 +8002,13 @@
     forum_get_recent_mod_activity($recentposts, $index, $lastlogin, $course->id, $cm->id);
 
     if (is_array($recentposts) && count($recentposts)>0) {
-        $recentkey = $navref->add(get_string('recentactivity').' ('.count($recentposts).')');
-        $navref->get($recentkey)->mainnavonly = true;
+        $recentnode = $navref->add(get_string('recentactivity').' ('.count($recentposts).')');
+        $recentnode->mainnavonly = true;
         foreach ($recentposts as $post) {
             $icon = new pix_icon('i/feedback', '');
             $url = new moodle_url('/mod/forum/discuss.php', array('d'=>$post->content->discussion));
             $title = $post->content->subject."\n".userdate($post->timestamp, get_string('strftimerecent', 'langconfig'))."\n".$post->user->firstname.' '.$post->user->lastname;
-            $navref->get($recentkey)->add($title, $url, navigation_node::TYPE_SETTING, null, null, $icon);
+            $recentnode->add($title, $url, navigation_node::TYPE_SETTING, null, null, $icon);
         }
     }
 }
@@ -8027,10 +8027,10 @@
         $PAGE->cm->context = get_context_instance(CONTEXT_MODULE, $PAGE->cm->instance);
     }
     if (is_enrolled($PAGE->cm->context)) { // means enrolled users only
-        $notekey = false;
+        $notenode = false;
         $helpbutton = false;
         if (forum_is_forcesubscribed($forumobject)) {
-            $notekey = $forumnode->add(get_string("forcessubscribe", 'forum'));
+            $notenode = $forumnode->add(get_string("forcessubscribe", 'forum'));
             $string = get_string('allowchoice', 'forum');
             $helpbutton = $OUTPUT->old_help_icon("subscription", $string, "forum");
             if (has_capability('mod/forum:managesubscriptions', $PAGE->cm->context)) {
@@ -8041,11 +8041,11 @@
             }
         } else if ($forumobject->forcesubscribe == FORUM_DISALLOWSUBSCRIBE) {
             $string = get_string('disallowsubscribe', 'forum');
-            $notekey = $forumnode->add($string);
+            $notenode = $forumnode->add($string);
             $helpbutton = $OUTPUT->old_help_icon("subscription", $string, "forum");
         } else {
             $string = get_string("forcesubscribe", "forum");
-            $notekey = $forumnode->add(get_string("allowsallsubscribe", 'forum'));
+            $notenode = $forumnode->add(get_string("allowsallsubscribe", 'forum'));
             $helpbutton = $OUTPUT->old_help_icon("subscription", $string, "forum");
 
             if (has_capability('mod/forum:managesubscriptions', $PAGE->cm->context)) {
@@ -8081,10 +8081,10 @@
             $url = new moodle_url('/mod/forum/settracking.php', array('id'=>$forumobject->id));
             $forumnode->add($linktext, $url, navigation_node::TYPE_SETTING);
         }
-        if ($notekey!==false) {
-            $forumnode->get($notekey)->add_class('note');
+        if ($notenode!==false) {
+            $notenode->add_class('note');
             if ($helpbutton!==false) {
-                $forumnode->get($notekey)->helpbutton = $helpbutton;
+                $notenode->helpbutton = $helpbutton;
             }
         }
         }
